"""
This code was tested against Python 3.9

Author: Ludvik Jerabek
Package: et_api
License: MIT
"""
from requests import Response

from et_api.web.Dictionary import Dictionary


class MalwareInfo(Dictionary):
    def __init__(self, response: Response):
        super().__init__(response)

    @property
    def md5sum(self) -> str:
        return self.response.get('md5sum', None)

    @property
    def submit_date(self) -> str:
        return self.response.get('submit_date', None)

    @property
    def file_type(self) -> str:
        return self.response.get('file_type', None)

    @property
    def file_size(self) -> str:
        return self.response.get('file_size', None)

    @property
    def sha256(self) -> str:
        return self.response.get('sha256', None)
